#include <mega128.h>
#include <delay.h>

#include "led.h"

#define MLED_PORT		PORTA
#define MLED_DDR		DDRA
#define MLED_DATA		0x01
#define MLED_SHIFT	0x02
#define MLED_CLEAR	0x04
#define MLED_LATCH1	0x10
#define MLED_LATCH2	0x20


void matrix_led(unsigned int data)
{
	unsigned int tmp = ~data;
	int i;

	MLED_PORT |= MLED_CLEAR;
	MLED_PORT &= ~(MLED_LATCH1 | MLED_LATCH2);
	for( i = 0; i < 16; i++ ) {
		if( tmp & 0x8000 )	MLED_PORT |= MLED_DATA;
		else				MLED_PORT &= ~MLED_DATA;

		MLED_PORT |= MLED_SHIFT;
		tmp <<= 1;
		MLED_PORT &= ~MLED_SHIFT;
	}

	MLED_PORT |= (MLED_LATCH1 | MLED_LATCH2);
	MLED_PORT &= ~(MLED_LATCH1 | MLED_LATCH2);
}

void matrix_alloff(void)
{
	int i;

	MLED_PORT |= MLED_CLEAR;
	MLED_PORT &= ~(MLED_LATCH1 | MLED_LATCH2);
	for( i = 0; i < 16; i++ ) {
		MLED_PORT |= MLED_DATA;

		MLED_PORT |= MLED_SHIFT;
		MLED_PORT &= ~MLED_SHIFT;
	}

	MLED_PORT |= (MLED_LATCH1 | MLED_LATCH2);
	MLED_PORT &= ~(MLED_LATCH1 | MLED_LATCH2);
}

void matrix_allon(void)
{
	MLED_PORT &= ~MLED_CLEAR;
	MLED_PORT |= (MLED_LATCH1 | MLED_LATCH2);
	MLED_PORT &= ~(MLED_LATCH1 | MLED_LATCH2);
}

void matrix_init(void)
{
	MLED_DDR = 0xFF;
	MLED_PORT = 0x00;

	matrix_alloff();
}
